/******************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only
* intended for use with Renesas products. No other uses are authorized.
* This software is owned by Renesas Electronics Corporation and is protected
* under all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
* AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software
* and to discontinue the availability of this software. By using this software,
* you agree to the additional terms and conditions found by accessing the
* following link:
* http://www.renesas.com/disclaimer
*******************************************************************************
* Copyright (C) 2012 Renesas Electronics Corporation. All rights reserved.
*******************************************************************************
* File Name     : bus_init.h
* Version       : 1.00
* Device(s)     : SH7269
* Tool-Chain    : HEW, SuperH RISC engine Standard Toolchain v9.4.0.0
* H/W Platform  : RSK2+SH7269
* Description   : Header file for bus_init.c file
*******************************************************************************
* History       : DD.MM.YYYY Version Description
*               : 03.03.2012 1.00    First Release
******************************************************************************/

#ifndef _BUS_INIT_H
#define _BUS_INIT_H

/******************************************************************************
Macro Defines
******************************************************************************/
/* SDRAM Mode Register Address */
#define SDRAM_MODE      (*(volatile uint16_t *)(0xfffc5040))
#define CS0WCR_SETTING  (0x00000b41ul)
#define CS0BCR_SETTING  (0x00000400ul)

/******************************************************************************
Function Prototypes
******************************************************************************/
void configure_bus_and_memory (void);
void init_bsc_cs0 (void);
void init_bsc_cs3 (void);

#endif  /* _BUS_INIT_H */

/******************************************************************************
End of File
******************************************************************************/
