/*-------------------------------------------------------------------------
 *
 * __low_level_init template for the IAR C/C++ Compiler
 * for Renesas SH.
 *
 * Copyright 2009-2010 IAR Systems AB.
 *-------------------------------------------------------------------------
 *      This module contains the function `__low_level_init', a function
 *      that is called before the `main' function of the program.  Normally
 *      low-level initializations - such as setting the prefered interrupt
 *      level or setting the watchdog - can be performed here.
 *
 *      Note that this function is called before the data segments are
 *      initialized, this means that this function can't rely on the
 *      values of global or static variables.
 *
 *      When this function returns zero, the startup code will inhibit the
 *      initialization of the data segments.  The result is faster startup,
 *      the drawback is that neither global nor static data will be
 *      initialized.
 *-------------------------------------------------------------------------*/

/* Header file provides prototypes for hardware configuration functions. */
#include "hwsetup.h"

/*  Header file provides a structure to access on-chip I/O registers. */
#include "io7268.h"

#ifdef __cplusplus
extern "C" {
#endif
void enable_internal_ram( void );
void enable_internal_ram( void )
{
  /* SYSCR5 bits 0 to 3 set to 1: Enable internal RAM */
  CPG.SYSCR5.BYTE = 0x0F;
}

int __low_level_init ( void );
int __low_level_init ( void )
{
  HardwareSetup();
  return 1;
}

#ifdef __cplusplus
}
#endif
